diff --git a/daemon/graphdriver/zfs/zfs_solaris.go b/daemon/graphdriver/zfs/zfs_solaris.go
new file mode 100644
index 0000000..a9a174b
--- /dev/null
+++ b/daemon/graphdriver/zfs/zfs_solaris.go
@@ -0,0 +1,95 @@
+package zfs
+
+/*
+#include <sys/statvfs.h>
+#include <stdlib.h>
+
+static inline struct statvfs *getstatfs(char *s) {
+        struct statvfs *buf;
+        int err;
+        buf = (struct statvfs *)malloc(sizeof(struct statvfs));
+        err = statvfs(s, buf);
+        return buf;
+}
+*/
+import "C"
+import (
+	"fmt"
+	zfs "github.com/mistifyio/go-zfs"
+	"path/filepath"
+	"strings"
+	"unsafe"
+
+	log "github.com/Sirupsen/logrus"
+	"github.com/docker/docker/daemon/graphdriver"
+)
+
+var mountOptions = map[string]string{"mountpoint": "legacy", "zoned": "on"}
+
+func checkRootdirFs(rootdir string) error {
+
+	cs := C.CString(filepath.Dir(rootdir))
+	buf := C.getstatfs(cs)
+
+	// on Solaris buf.f_basetype contains ['z', 'f', 's', 0 ... ]
+	if (buf.f_basetype[0] != 122) || (buf.f_basetype[1] != 102) || (buf.f_basetype[2] != 115) ||
+		(buf.f_basetype[3] != 0) {
+		log.Debugf("[zfs] no zfs dataset found for rootdir '%s'", rootdir)
+		C.free(unsafe.Pointer(buf))
+		return graphdriver.ErrPrerequisites
+	}
+
+	C.free(unsafe.Pointer(buf))
+	C.free(unsafe.Pointer(cs))
+	return nil
+}
+
+/* rootfs is introduced to comply with the OCI spec
+which states that root filesystem must be mounted at <CID>/rootfs/ instead of <CID>/
+*/
+func getMountpoint(id string) string {
+	maxlen := 12
+
+	// we need to preserve filesystem suffix
+	suffix := strings.SplitN(id, "-", 2)
+
+	if len(suffix) > 1 {
+		return filepath.Join(id[:maxlen]+"-"+suffix[1], "rootfs", "root")
+	}
+
+	return filepath.Join(id[:maxlen], "rootfs", "root")
+}
+
+// Status returns information about the ZFS filesystem. It returns a two dimensional array of information
+// such as pool name, dataset name, disk usage, parent quota and compression used.
+// Currently it return 'Zpool', 'Zpool Health', 'Parent Dataset', 'Space Used By Parent',
+// 'Space Available', 'Parent Quota' and 'Compression'.
+func (d *Driver) Status() [][2]string {
+	parts := strings.Split(d.dataset.Name, "/")
+	pool, err := zfs.GetZpool(parts[0])
+
+	fmt.Printf("Graph Driver status dataset is: %+v\n", d.dataset)
+	var poolName, poolHealth string
+	if err == nil {
+		poolName = pool.Name
+		poolHealth = pool.Health
+	} else {
+		poolName = fmt.Sprintf("error while getting pool information %v", err)
+		poolHealth = "not available"
+	}
+
+	quota := "no"
+	if d.dataset.Quota != "" {
+		quota = d.dataset.Quota
+	}
+
+	return [][2]string{
+		{"Zpool", poolName},
+		{"Zpool Health", poolHealth},
+		{"Parent Dataset", d.dataset.Name},
+		{"Space Used By Parent", d.dataset.Used},
+		{"Space Available", d.dataset.Avail},
+		{"Parent Quota", quota},
+		{"Compression", d.dataset.Compression},
+	}
+}
diff --git a/daemon/graphdriver/zfs/zfs_unsupported.go b/daemon/graphdriver/zfs/zfs_unsupported.go
index 643b169..ce8daad 100644
--- a/daemon/graphdriver/zfs/zfs_unsupported.go
+++ b/daemon/graphdriver/zfs/zfs_unsupported.go
@@ -1,4 +1,4 @@
-// +build !linux,!freebsd
+// +build !linux,!freebsd,!solaris
 
 package zfs
 
diff --git a/daemon/info.go b/daemon/info.go
index 008ac20..3d86bc0 100644
--- a/daemon/info.go
+++ b/daemon/info.go
@@ -134,11 +134,9 @@ func (daemon *Daemon) SystemInfo() (*types.Info, error) {
 func (daemon *Daemon) SystemVersion() types.Version {
 	v := types.Version{
 		Version:      dockerversion.Version,
-		GitCommit:    dockerversion.GitCommit,
 		GoVersion:    runtime.Version(),
 		Os:           runtime.GOOS,
 		Arch:         runtime.GOARCH,
-		BuildTime:    dockerversion.BuildTime,
 		Experimental: utils.ExperimentalBuild(),
 	}
 
diff --git a/daemon/inspect_solaris.go b/daemon/inspect_solaris.go
new file mode 100644
index 0000000..e42a61d
--- /dev/null
+++ b/daemon/inspect_solaris.go
@@ -0,0 +1,30 @@
+package daemon
+
+import (
+	"github.com/docker/docker/container"
+	"github.com/docker/engine-api/types"
+)
+
+// This sets platform-specific fields
+func setPlatformSpecificContainerFields(container *container.Container, contJSONBase *types.ContainerJSONBase) *types.ContainerJSONBase {
+	return contJSONBase
+}
+
+func addMountPoints(container *container.Container) []types.MountPoint {
+	mountPoints := make([]types.MountPoint, 0, len(container.MountPoints))
+	for _, m := range container.MountPoints {
+		mountPoints = append(mountPoints, types.MountPoint{
+			Name:        m.Name,
+			Source:      m.Path(),
+			Destination: m.Destination,
+			Driver:      m.Driver,
+			RW:          m.RW,
+		})
+	}
+	return mountPoints
+}
+
+// containerInspectPre120 get containers for pre 1.20 APIs.
+func (daemon *Daemon) containerInspectPre120(name string) (*types.ContainerJSON, error) {
+	return daemon.containerInspectCurrent(name, false)
+}
diff --git a/daemon/inspect_unix.go b/daemon/inspect_unix.go
index b9321f3..d241711 100644
--- a/daemon/inspect_unix.go
+++ b/daemon/inspect_unix.go
@@ -1,4 +1,4 @@
-// +build !windows
+// +build !windows,!solaris
 
 package daemon
 
diff --git a/daemon/list_unix.go b/daemon/list_unix.go
index 8dccbe4..91c9cac 100644
--- a/daemon/list_unix.go
+++ b/daemon/list_unix.go
@@ -1,4 +1,4 @@
-// +build linux freebsd
+// +build linux freebsd solaris
 
 package daemon
 
diff --git a/daemon/network.go b/daemon/network.go
index f6a2515..0ffe17f 100644
--- a/daemon/network.go
+++ b/daemon/network.go
@@ -4,6 +4,7 @@ import (
 	"errors"
 	"fmt"
 	"net"
+	"runtime"
 	"strings"
 
 	derr "github.com/docker/docker/errors"
@@ -154,6 +155,9 @@ func getIpamConfig(data []network.IPAMConfig) ([]*libnetwork.IpamConf, []*libnet
 // network. If either cannot be found, an err is returned. If the
 // network cannot be set up, an err is returned.
 func (daemon *Daemon) ConnectContainerToNetwork(containerName, networkName string, endpointConfig *network.EndpointSettings) error {
+	if runtime.GOOS == "solaris" {
+		return errors.New("docker network connect is unsupported on Solaris platform\n")
+	}
 	container, err := daemon.GetContainer(containerName)
 	if err != nil {
 		return err
@@ -164,6 +168,9 @@ func (daemon *Daemon) ConnectContainerToNetwork(containerName, networkName strin
 // DisconnectContainerFromNetwork disconnects the given container from
 // the given network. If either cannot be found, an err is returned.
 func (daemon *Daemon) DisconnectContainerFromNetwork(containerName string, network libnetwork.Network, force bool) error {
+	if runtime.GOOS == "solaris" {
+		return errors.New("docker network disconnect is unsupported on Solaris platform\n")
+	}
 	container, err := daemon.GetContainer(containerName)
 	if err != nil {
 		if force {
diff --git a/daemon/selinux_unsupported.go b/daemon/selinux_unsupported.go
index 25a56ad..4f9bbe4 100644
--- a/daemon/selinux_unsupported.go
+++ b/daemon/selinux_unsupported.go
@@ -2,6 +2,10 @@
 
 package daemon
 
+import (
+	containertypes "github.com/docker/engine-api/types/container"
+)
+
 func selinuxSetDisabled() {
 }
 
@@ -11,3 +15,7 @@ func selinuxFreeLxcContexts(label string) {
 func selinuxEnabled() bool {
 	return false
 }
+
+func mergeLxcConfIntoOptions(hostConfig *containertypes.HostConfig) ([]string, error) {
+	return nil, nil
+}
diff --git a/daemon/start.go b/daemon/start.go
index 418dace..50b1cc1 100644
--- a/daemon/start.go
+++ b/daemon/start.go
@@ -1,6 +1,8 @@
 package daemon
 
 import (
+	"errors"
+	"os"
 	"runtime"
 
 	"github.com/Sirupsen/logrus"
@@ -10,6 +12,8 @@ import (
 	containertypes "github.com/docker/engine-api/types/container"
 )
 
+const SVCCFG = "/usr/sbin/svccfg"
+
 // ContainerStart starts a container.
 func (daemon *Daemon) ContainerStart(name string, hostConfig *containertypes.HostConfig) error {
 	container, err := daemon.GetContainer(name)
@@ -142,6 +146,18 @@ func (daemon *Daemon) containerStart(container *container.Container) (err error)
 	mounts = append(mounts, container.TmpfsMounts()...)
 
 	container.Command.Mounts = mounts
+
+	if runtime.GOOS == "solaris" {
+		img, _ := daemon.LookupImage(container.Config.Image)
+		// XXX Avoid docker to run linux images without brand-pmx pkg
+		if _, err := os.Stat("/usr/lib/brand/lx/config.xml"); os.IsNotExist(err) {
+			if img.Os != "solaris" {
+				return errors.New("Platform on which parent image was created is not Solaris\n")
+			}
+		}
+		container.Command.ContOS = img.Os
+	}
+
 	if err := daemon.waitForStart(container); err != nil {
 		return err
 	}
diff --git a/daemon/stats_collector_solaris.go b/daemon/stats_collector_solaris.go
new file mode 100644
index 0000000..4d4b4a0
--- /dev/null
+++ b/daemon/stats_collector_solaris.go
@@ -0,0 +1,537 @@
+package daemon
+
+import (
+	"bufio"
+	"github.com/Sirupsen/logrus"
+	"github.com/docker/docker/container"
+	"github.com/docker/docker/daemon/execdriver"
+	"github.com/docker/docker/pkg/pubsub"
+	"github.com/docker/docker/pkg/system"
+	"github.com/docker/libnetwork/types"
+	"github.com/opencontainers/runc/libcontainer"
+	"github.com/opencontainers/runc/libcontainer/zones"
+	"strings"
+	"sync"
+	"time"
+)
+
+/*
+
+#cgo LDFLAGS: -lzonestat -lkstat2
+
+#include <errno.h>
+#include <kstat2.h>
+#include <string.h>
+#include <strings.h>
+#include <stdlib.h>
+#include <zone.h>
+#include <zonestat.h>
+#include <sys/param.h>
+
+typedef struct z_iostat {
+	int64_t	nread;
+	int64_t	read_bytes;
+	int64_t nwrite;
+	int64_t write_bytes;
+} z_iostat_t;
+
+typedef struct z_netstat {
+	int64_t	ibytes;
+	int64_t	ipackets;
+	int64_t ierrors;
+	int64_t	idrops;
+	int64_t	obytes;
+	int64_t	opackets;
+	int64_t oerrors;
+	int64_t	odrops;
+} z_netstat_t;
+
+#define KSTAT2_IO_URI	"kstat:/misc/unix/vopstats_zfs/%d"
+z_iostat_t *
+get_io_stats(zoneid_t zoneid) {
+	kstat2_handle_t handle;
+	kstat2_status_t stat;
+	kstat2_map_t    map;
+	kstat2_mapiter_t iter;
+	boolean_t has_next;
+	z_iostat_t *zio = malloc(sizeof(*zio));
+
+	if (zio == NULL) {
+		errno = ENOMEM;
+		return (NULL);
+	}
+	char lookup_uri[sizeof(KSTAT2_IO_URI) + 10]; // 12 extra digits
+
+	(void) snprintf(lookup_uri, sizeof(lookup_uri), KSTAT2_IO_URI, zoneid);
+
+	stat = kstat2_open(&handle, NULL);
+	if (stat != KSTAT2_S_OK) {
+		return (NULL);
+	}
+
+	stat = kstat2_lookup_map(handle, lookup_uri, &map);
+	if (stat != KSTAT2_S_OK) {
+		(void) kstat2_close(&handle);
+		return (NULL);
+	}
+
+	if ((stat = kstat2_mapiter_start(map, KSTAT2_NVK_ALL, &iter)) !=
+	    KSTAT2_S_OK) {
+		(void) kstat2_close(&handle);
+		return (NULL);
+	}
+
+	while (kstat2_mapiter_hasnext(iter, &has_next) == KSTAT2_S_OK &&
+	    has_next) {
+		kstat2_nv_t val;
+
+		if (kstat2_mapiter_next(iter, &val) != KSTAT2_S_OK) {
+			continue;
+		}
+
+		if (!strcmp(val->name, "nread") && (val->type == KSTAT2_NVVT_INT))
+			zio->nread = val->data.integer;
+		else if (!strcmp(val->name, "read_bytes") && (val->type == KSTAT2_NVVT_INT))
+			zio->read_bytes = val->data.integer;
+		else if (!strcmp(val->name, "nwrite") && (val->type == KSTAT2_NVVT_INT))
+			zio->nwrite = val->data.integer;
+		else if (!strcmp(val->name, "write_bytes") && (val->type == KSTAT2_NVVT_INT))
+			zio->write_bytes = val->data.integer;
+	}
+
+	(void) kstat2_close(&handle);
+	return (zio);
+}
+
+void
+io_stats_free(z_iostat_t *p)
+{
+	free(p);
+}
+
+#define KSTAT2_NET_LINK_URI	"kstat:/net/link"
+
+z_netstat_t *
+get_net_stats(const char *linkname, zoneid_t zoneid) {
+	kstat2_handle_t handle;
+	kstat2_status_t stat;
+	kstat2_map_t    map;
+	kstat2_mapiter_t iter;
+	boolean_t has_next;
+	// URI prefix + '/' + max data link name + '/' + zoneid digits + '\0'
+	char lookup_uri[sizeof(KSTAT2_NET_LINK_URI) + MAXLINKNAMELEN + 12];
+	z_netstat_t *zns = calloc(1, sizeof(*zns));
+
+	if (zns == NULL) {
+		errno = ENOMEM;
+		return (NULL);
+	}
+
+	(void) snprintf(lookup_uri, sizeof(lookup_uri), "%s/%s/%d",
+	    KSTAT2_NET_LINK_URI, linkname, zoneid);
+
+	stat = kstat2_open(&handle, NULL);
+	if (stat != KSTAT2_S_OK) {
+		free(zns);
+		return (NULL);
+	}
+
+	stat = kstat2_lookup_map(handle, lookup_uri, &map);
+	if (stat != KSTAT2_S_OK) {
+		(void) kstat2_close(&handle);
+		free(zns);
+		return (NULL);
+	}
+
+	stat = kstat2_mapiter_start(map, KSTAT2_NVK_ALL, &iter);
+	if (stat != KSTAT2_S_OK) {
+		(void) kstat2_close(&handle);
+		free(zns);
+		return (NULL);
+	}
+
+	while (kstat2_mapiter_hasnext(iter, &has_next) == KSTAT2_S_OK &&
+	    has_next) {
+		kstat2_nv_t val;
+
+		if (kstat2_mapiter_next(iter, &val) != KSTAT2_S_OK ||
+		    val->type != KSTAT2_NVVT_INT) {
+			continue;
+		}
+
+		if (strcmp(val->name, "ipackets64") == 0) {
+			zns->ipackets = val->data.integer;
+		} else if (strcmp(val->name, "rbytes64") == 0) {
+			zns->ibytes = val->data.integer;
+		} else if (strcmp(val->name, "ierrors") == 0) {
+			zns->ierrors = val->data.integer;
+		} else if (strcmp(val->name, "dl_idrops") == 0) {
+			zns->idrops = val->data.integer;
+		} else if (strcmp(val->name, "opackets64") == 0) {
+			zns->opackets = val->data.integer;
+		} else if (strcmp(val->name, "obytes64") == 0) {
+			zns->obytes = val->data.integer;
+		} else if (strcmp(val->name, "oerrors") == 0) {
+			zns->oerrors = val->data.integer;
+		} else if (strcmp(val->name, "dl_odrops") == 0) {
+			zns->odrops = val->data.integer;
+		}
+	}
+
+	(void) kstat2_close(&handle);
+	return (zns);
+}
+
+void
+net_stats_free(z_netstat_t *p)
+{
+	free(p);
+}
+
+uint64_t
+getSystemCPUUsage(zs_usage_t usage)
+{
+	timestruc_t cpu;
+
+	zs_resource_total_time(usage, ZS_RESOURCE_CPU, &cpu);
+	return (1000000000ULL * cpu.tv_sec + cpu.tv_nsec);
+}
+
+char *
+get_zone_name(zs_zone_t z)
+{
+	zs_property_t prop;
+
+	prop = zs_zone_property(z, ZS_ZONE_PROP_NAME);
+	if (prop == NULL)
+		return (NULL);
+
+	return (zs_property_string(prop));
+}
+
+zs_usage_t
+get_usage(zs_ctl_t zsctl)
+{
+	zs_usage_t zsu;
+
+        while ((zsu = zs_usage_read(zsctl)) == NULL &&
+	    (errno == EINTR || errno == EAGAIN))
+		;
+
+	return (zsu);
+}
+
+uint64_t
+getCpuUsage(zs_zone_t z)
+{
+	timestruc_t cpu;
+
+	zs_resource_used_zone_time(z, ZS_RESOURCE_CPU, &cpu);
+	return ((uint64_t)(cpu.tv_sec * 1000000000ULL + cpu.tv_nsec));
+}
+
+*/
+import "C"
+
+func getZoneName(z C.zs_zone_t) string {
+	return C.GoString(C.get_zone_name(z))
+}
+
+// XXX solaris: TODO Copied from Windows, refactor accordingly for collector actions.
+// XXX: Copied statsCollector struct and interface from unix
+
+type statsSupervisor interface {
+	// GetZoneStats collects all the stats related to a zone container
+	getZoneStats(z C.zs_zone_t, zoneid uint64, container *container.Container) (*execdriver.ResourceStats, error)
+}
+
+type zonePublisher struct {
+	publisher *pubsub.Publisher
+	zoneid    uint64
+}
+
+// newStatsCollector returns a new statsCollector for collection stats
+// for a registered container at the specified interval. The collector allows
+// non-running containers to be added and will start processing stats when
+// they are started.
+func (daemon *Daemon) newStatsCollector(interval time.Duration) *statsCollector {
+	s := &statsCollector{
+		interval:   interval,
+		supervisor: daemon,
+		publishers: make(map[*container.Container]*zonePublisher),
+		bufReader:  bufio.NewReaderSize(nil, 128),
+	}
+	go s.run()
+
+	return s
+}
+
+// statsCollector manages and provides container resource stats
+type statsCollector struct {
+	m          sync.Mutex
+	supervisor statsSupervisor
+	interval   time.Duration
+	publishers map[*container.Container]*zonePublisher
+	bufReader  *bufio.Reader
+}
+
+// collect registers the container with the collector and adds it to
+
+// the event loop for collection on the specified interval returning
+// a channel for the subscriber to receive on.
+func (s *statsCollector) collect(c *container.Container) chan interface{} {
+	s.m.Lock()
+	defer s.m.Unlock()
+	zpub, exists := s.publishers[c]
+	if !exists {
+		zid, err := C.getzoneidbyname(C.CString(strings.TrimPrefix(c.Name, "/")))
+		if err != nil {
+			// Too early to get zoneid, flag and defer
+			zid = 0
+		}
+		zpub = &zonePublisher{
+			publisher: pubsub.NewPublisher(100*time.Millisecond, 1024),
+			zoneid:    uint64(zid),
+		}
+		s.publishers[c] = zpub
+	}
+	return zpub.publisher.Subscribe()
+}
+
+// stopCollection closes the channels for all subscribers and removes
+// the container from metrics collection.
+func (s *statsCollector) stopCollection(c *container.Container) {
+	s.m.Lock()
+	defer s.m.Unlock()
+	if zpub, exists := s.publishers[c]; exists {
+		zpub.publisher.Close()
+		delete(s.publishers, c)
+	}
+}
+
+// unsubscribe removes a specific subscriber from receiving updates for a container's stats.
+func (s *statsCollector) unsubscribe(c *container.Container, ch chan interface{}) {
+	s.m.Lock()
+	defer s.m.Unlock()
+	zpub, exists := s.publishers[c]
+	if exists {
+		zpub.publisher.Evict(ch)
+		if zpub.publisher.Len() == 0 {
+			delete(s.publishers, c)
+		}
+	}
+}
+
+// XXX copied from unix
+func (s *statsCollector) run() {
+	type publishersPair struct {
+		container *container.Container
+		zpub      *zonePublisher
+	}
+	memoryInfo, err := system.ReadMemInfo()
+	machineMemory := memoryInfo.MemTotal
+
+	// we cannot determine the capacity here.
+	// it will grow enough in first iteration
+	pairs := make(map[string]publishersPair)
+
+	zsctl := C.zs_open()
+	usage_last, err := C.get_usage(zsctl)
+	if usage_last == nil {
+		logrus.Error("Failed to get usage: ", err)
+		C.zs_close(zsctl)
+		return
+	}
+	for range time.Tick(s.interval) {
+		var usage_diff C.zs_usage_t
+
+		s.m.Lock()
+		for container, zpub := range s.publishers {
+			// copy pointers here to release the lock ASAP
+			pairs[strings.TrimPrefix(container.Name, "/")] = publishersPair{container, zpub}
+		}
+		s.m.Unlock()
+		if len(pairs) == 0 {
+			continue
+		}
+
+		usage, err := C.get_usage(zsctl)
+		if usage != nil {
+			usage_diff = C.zs_usage_diff(usage_last, usage)
+		}
+		if usage == nil || usage_diff == nil {
+			logrus.Error("Failed to get usage: ", err)
+			// empty the map
+			for name, _ := range pairs {
+				delete(pairs, name)
+			}
+			continue
+		}
+		systemUsage := uint64(C.getSystemCPUUsage(usage_diff))
+
+		var z C.zs_zone_t
+		z = nil
+		for z = C.zs_zone_walk(usage_diff, z); z != nil; z = C.zs_zone_walk(usage_diff, z) {
+			name := getZoneName(z)
+			pair, ok := pairs[name]
+			if ok == false {
+				continue
+			}
+			zoneid := pair.zpub.zoneid
+			if zoneid == 0 {
+				zid, err := C.getzoneidbyname(C.CString(name))
+				if err != nil {
+					// zoneid is not available yet
+					delete(pairs, name)
+					continue
+				}
+				pair.zpub.zoneid = uint64(zid)
+				zoneid = pair.zpub.zoneid
+			}
+			stats, err := s.supervisor.getZoneStats(z, zoneid, pair.container)
+			if err != nil {
+				if err != execdriver.ErrNotRunning {
+					logrus.Errorf("collecting stats for %s: %v", pair.container.ID, err)
+				}
+				delete(pairs, name)
+				continue
+			}
+			if stats.MemoryLimit == 0 {
+				stats.MemoryLimit = machineMemory
+			}
+			stats.SystemUsage = systemUsage
+
+			pair.zpub.publisher.Publish(stats)
+			delete(pairs, name)
+		}
+		C.zs_usage_free(usage_last)
+		C.zs_usage_free(usage_diff)
+		usage_last = usage
+	}
+	C.zs_close(zsctl)
+}
+
+func getIOStats(zoneid uint64) (*zones.BlkioStats, error) {
+	iostats, err := C.get_io_stats(C.zoneid_t(zoneid))
+	if iostats == nil {
+		return nil, err
+	}
+
+	ioBytes := []zones.BlkioStatEntry{
+		{
+			Op:    "write",
+			Value: uint64(iostats.write_bytes),
+		},
+		{
+			Op:    "read",
+			Value: uint64(iostats.read_bytes),
+		},
+	}
+	ioCount := []zones.BlkioStatEntry{
+		{
+			Op:    "write",
+			Value: uint64(iostats.nwrite),
+		},
+		{
+			Op:    "read",
+			Value: uint64(iostats.nread),
+		},
+	}
+	C.io_stats_free(iostats)
+	ioStats := zones.BlkioStats{
+		IoServiceBytesRecursive: ioBytes,
+		IoServicedRecursive:     ioCount,
+	}
+
+	return &ioStats, nil
+}
+
+func getNetStats(zoneid uint64) ([]*libcontainer.NetworkInterface, error) {
+	m := make(map[string]*types.InterfaceStatistics)
+	s := types.InterfaceStatistics{}
+
+	// XXX: Should get an array with all data links in the container from its
+	// configuration. For now, net0 suffices. If multi-homed containers are allowed
+	// in the future, this will be required to have accuarte network statistics.
+	datalink := []string{"net0"}
+	for _, linkname := range datalink {
+		ns, err := C.get_net_stats(C.CString(linkname), C.zoneid_t(zoneid))
+		if ns == nil {
+			return nil, err
+		}
+
+		s.RxBytes = uint64(ns.ibytes)
+		s.RxPackets = uint64(ns.ipackets)
+		s.RxErrors = uint64(ns.ierrors)
+		s.RxDropped = uint64(ns.idrops)
+
+		s.TxBytes = uint64(ns.obytes)
+		s.TxPackets = uint64(ns.opackets)
+		s.TxErrors = uint64(ns.oerrors)
+		s.TxDropped = uint64(ns.odrops)
+		m[linkname] = &s
+		C.net_stats_free(ns)
+
+	}
+	// Convert libnetwork nw stats into libcontainer nw stats
+	var list []*libcontainer.NetworkInterface
+	for ifName, ifStats := range m {
+		list = append(list, convertLnNetworkStats(ifName, ifStats))
+	}
+
+	return list, nil
+}
+
+func getContainerStats(z C.zs_zone_t, zoneid uint64) (*libcontainer.Stats, error) {
+	cstats := &libcontainer.Stats{}
+	zstats := zones.Stats{}
+	iostats, err := getIOStats(zoneid)
+	if iostats == nil {
+		return nil, err
+	}
+
+	// For now we only retrieve what's needed by docker stats
+	cpuUsage := uint64(C.getCpuUsage(z))
+	memUsage := uint64(C.zs_resource_used_zone_uint64(z, C.ZS_RESOURCE_RAM_RSS))
+
+	// XXX: Need to use kstat2 for CPU usage
+	// CPU% only seems to work if all these fields are populated.
+	// Once kstat2 are used, these statistics will be filled accurately.
+	zstats.CpuStats.CpuUsage.PercpuUsage = []uint64{cpuUsage}
+	zstats.CpuStats.CpuUsage.TotalUsage = uint64(cpuUsage)
+	zstats.CpuStats.CpuUsage.UsageInKernelmode = uint64(cpuUsage)
+	zstats.CpuStats.CpuUsage.UsageInUsermode = uint64(cpuUsage)
+	zstats.MemoryStats.Usage.Usage = memUsage
+	zstats.BlkioStats = *iostats
+
+	cstats.Stats = &zstats
+
+	return cstats, nil
+}
+
+func (daemon *Daemon) getZoneStats(z C.zs_zone_t, zoneid uint64, container *container.Container) (*execdriver.ResourceStats, error) {
+
+	zstats, err := getContainerStats(z, zoneid)
+	if zstats == nil {
+		return nil, err
+	}
+	netstats, err := getNetStats(zoneid)
+	if netstats == nil {
+		return nil, err
+	}
+
+	memoryLimit := int64(C.zs_zone_limit_uint64(z, C.ZS_LIMIT_RAM_RSS))
+
+	if memoryLimit == C.ZS_LIMIT_NONE {
+		memoryLimit = 0
+	}
+
+	zstats.Interfaces = netstats
+	stats := &execdriver.ResourceStats{
+		Read:        time.Now(),
+		MemoryLimit: memoryLimit,
+		Stats:       zstats,
+	}
+
+	return stats, nil
+}
diff --git a/daemon/stats_collector_unix.go b/daemon/stats_collector_unix.go
index 2fd368c..ec408c6 100644
--- a/daemon/stats_collector_unix.go
+++ b/daemon/stats_collector_unix.go
@@ -1,4 +1,4 @@
-// +build !windows
+// +build !windows,!solaris
 
 package daemon
 
diff --git a/daemon/stats_solaris.go b/daemon/stats_solaris.go
new file mode 100644
index 0000000..a1230c6
--- /dev/null
+++ b/daemon/stats_solaris.go
@@ -0,0 +1,84 @@
+package daemon
+
+import (
+	"github.com/docker/engine-api/types"
+	"github.com/opencontainers/runc/libcontainer"
+	"github.com/opencontainers/runc/libcontainer/zones"
+)
+
+// convertStatsToAPITypes converts the libcontainer.Stats to the api specific
+// structs. This is done to preserve API compatibility and versioning.
+func convertStatsToAPITypes(ls *libcontainer.Stats) *types.StatsJSON {
+	// XXX solaris TODO Copied from Windows. Refactor accordingly to fill in stats.
+	s := &types.StatsJSON{}
+	cs := ls.Stats
+
+	if ls.Interfaces != nil {
+		s.Networks = make(map[string]types.NetworkStats)
+		for _, iface := range ls.Interfaces {
+			// For API Version >= 1.21, the original data of network will
+			// be returned.
+			s.Networks[iface.Name] = types.NetworkStats{
+				RxBytes:   iface.RxBytes,
+				RxPackets: iface.RxPackets,
+				RxErrors:  iface.RxErrors,
+				RxDropped: iface.RxDropped,
+				TxBytes:   iface.TxBytes,
+				TxPackets: iface.TxPackets,
+				TxErrors:  iface.TxErrors,
+				TxDropped: iface.TxDropped,
+			}
+		}
+	}
+
+	if cs == nil {
+		return s
+	}
+
+	s.BlkioStats = types.BlkioStats{
+		IoServiceBytesRecursive: copyBlkioEntry(cs.BlkioStats.IoServiceBytesRecursive),
+		IoServicedRecursive:     copyBlkioEntry(cs.BlkioStats.IoServicedRecursive),
+		IoQueuedRecursive:       copyBlkioEntry(cs.BlkioStats.IoQueuedRecursive),
+		IoServiceTimeRecursive:  copyBlkioEntry(cs.BlkioStats.IoServiceTimeRecursive),
+		IoWaitTimeRecursive:     copyBlkioEntry(cs.BlkioStats.IoWaitTimeRecursive),
+		IoMergedRecursive:       copyBlkioEntry(cs.BlkioStats.IoMergedRecursive),
+		IoTimeRecursive:         copyBlkioEntry(cs.BlkioStats.IoTimeRecursive),
+		SectorsRecursive:        copyBlkioEntry(cs.BlkioStats.SectorsRecursive),
+	}
+	cpu := cs.CpuStats
+	s.CPUStats = types.CPUStats{
+		CPUUsage: types.CPUUsage{
+			TotalUsage:        cpu.CpuUsage.TotalUsage,
+			PercpuUsage:       cpu.CpuUsage.PercpuUsage,
+			UsageInKernelmode: cpu.CpuUsage.UsageInKernelmode,
+			UsageInUsermode:   cpu.CpuUsage.UsageInUsermode,
+		},
+		ThrottlingData: types.ThrottlingData{
+			Periods:          cpu.ThrottlingData.Periods,
+			ThrottledPeriods: cpu.ThrottlingData.ThrottledPeriods,
+			ThrottledTime:    cpu.ThrottlingData.ThrottledTime,
+		},
+	}
+	mem := cs.MemoryStats
+	s.MemoryStats = types.MemoryStats{
+		Usage:    mem.Usage.Usage,
+		MaxUsage: mem.Usage.MaxUsage,
+		Stats:    mem.Stats,
+		Failcnt:  mem.Usage.Failcnt,
+	}
+
+	return s
+}
+
+func copyBlkioEntry(entries []zones.BlkioStatEntry) []types.BlkioStatEntry {
+	out := make([]types.BlkioStatEntry, len(entries))
+	for i, re := range entries {
+		out[i] = types.BlkioStatEntry{
+			Major: re.Major,
+			Minor: re.Minor,
+			Op:    re.Op,
+			Value: re.Value,
+		}
+	}
+	return out
+}
diff --git a/docker/daemon_solaris.go b/docker/daemon_solaris.go
new file mode 100644
index 0000000..ee22de9
--- /dev/null
+++ b/docker/daemon_solaris.go
@@ -0,0 +1,58 @@
+// +build daemon,solaris
+
+package main
+
+import (
+	"fmt"
+	"os"
+	"syscall"
+
+	apiserver "github.com/docker/docker/api/server"
+	"github.com/docker/docker/daemon"
+	"github.com/docker/docker/pkg/mflag"
+	"github.com/docker/docker/pkg/system"
+
+	_ "github.com/docker/docker/daemon/execdriver/native"
+)
+
+//XXX Solaris
+//const defaultDaemonConfigFile = "/etc/docker/daemon.json"
+const defaultDaemonConfigFile = ""
+
+func setPlatformServerConfig(serverConfig *apiserver.Config, daemonCfg *daemon.Config) *apiserver.Config {
+	return serverConfig
+}
+
+// currentUserIsOwner checks whether the current user is the owner of the given
+// file.
+func currentUserIsOwner(f string) bool {
+	if fileInfo, err := system.Stat(f); err == nil && fileInfo != nil {
+		if int(fileInfo.UID()) == os.Getuid() {
+			return true
+		}
+	}
+	return false
+}
+
+// setDefaultUmask sets the umask to 0022 to avoid problems
+// caused by custom umask
+func setDefaultUmask() error {
+	desiredUmask := 0022
+	syscall.Umask(desiredUmask)
+	if umask := syscall.Umask(desiredUmask); umask != desiredUmask {
+		return fmt.Errorf("failed to set umask: expected %#o, got %#o", desiredUmask, umask)
+	}
+
+	return nil
+}
+
+func getDaemonConfDir() string {
+	return "/etc/docker"
+}
+
+func setupConfigReloadTrap(configFile string, flags *mflag.FlagSet, reload func(*daemon.Config)) {
+}
+
+// notifySystem sends a message to the host when the server is ready to be used
+func notifySystem() {
+}
diff --git a/docker/daemon_unix.go b/docker/daemon_unix.go
index ef90970..67fb35d 100644
--- a/docker/daemon_unix.go
+++ b/docker/daemon_unix.go
@@ -1,4 +1,4 @@
-// +build daemon,!windows
+// +build daemon,!windows,!solaris
 
 package main
 
diff --git a/hack/.vendor-helpers.sh b/hack/.vendor-helpers.sh
index e3be72b..b2fa5ef 100755
--- a/hack/.vendor-helpers.sh
+++ b/hack/.vendor-helpers.sh
@@ -13,7 +13,7 @@ if ! go list github.com/docker/docker/docker &> /dev/null; then
 fi
 export GOPATH="$GOPATH:${PWD}/vendor"
 
-find='find'
+find='gfind'
 if [ "$(go env GOHOSTOS)" = 'windows' ]; then
 	find='/usr/bin/find'
 fi
@@ -126,12 +126,12 @@ clean() {
 	local prune=( $($find vendor -depth -type d -not '(' "${findArgs[@]}" ')') )
 	unset IFS
 	for dir in "${prune[@]}"; do
-		$find "$dir" -maxdepth 1 -not -type d -not -name 'LICENSE*' -not -name 'COPYING*' -exec rm -v -f '{}' ';'
+		$find "$dir" -maxdepth 1 -not -type d -not -name 'LICENSE*' -not -name 'COPYING*' -exec grm -v -f '{}' ';'
 		rmdir "$dir" 2>/dev/null || true
 	done
 
 	echo -n 'pruning unused files, '
-	$find vendor -type f -name '*_test.go' -exec rm -v '{}' ';'
+	$find vendor -type f -name '*_test.go' -exec grm -v '{}' ';'
 
 	echo done
 }
@@ -143,5 +143,5 @@ fix_rewritten_imports () {
        local target="vendor/src/$pkg"
 
        echo "$pkg: fixing rewritten imports"
-       $find "$target" -name \*.go -exec sed -i -e "s|\"${remove}|\"|g" {} \;
+       $find "$target" -name \*.go -exec gsed -i -e "s|\"${remove}|\"|g" {} \;
 }
diff --git a/hack/make.sh b/hack/make.sh
index ca01fd8..464011a 100755
--- a/hack/make.sh
+++ b/hack/make.sh
@@ -71,7 +71,7 @@ if command -v git &> /dev/null && git rev-parse &> /dev/null; then
 	if [ -n "$(git status --porcelain --untracked-files=no)" ]; then
 		GITCOMMIT="$GITCOMMIT-unsupported"
 	fi
-	! BUILDTIME=$(date --rfc-3339 ns | sed -e 's/ /T/') &> /dev/null
+	! BUILDTIME=$(date --rfc-3339 ns 2> /dev/null | sed -e 's/ /T/')
 	if [ -z $BUILDTIME ]; then
 		# If using bash 3.1 which doesn't support --rfc-3389, eg Windows CI
 		BUILDTIME=$(date -u)
@@ -91,6 +91,12 @@ if [ "$AUTO_GOPATH" ]; then
 	mkdir -p .gopath/src/"$(dirname "${DOCKER_PKG}")"
 	ln -sf ../../../.. .gopath/src/"${DOCKER_PKG}"
 	export GOPATH="${PWD}/.gopath:${PWD}/vendor"
+
+	if [ "$(go env GOOS)" = 'solaris' ]; then
+		# sys/unix is installed outside the standard library on solaris
+		# XXX need to allow for version change, need to get version from go
+		export GOPATH="${GOPATH}:/usr/lib/gocode/1.5"
+	fi
 fi
 
 if [ ! "$GOPATH" ]; then
@@ -148,6 +154,12 @@ BUILDFLAGS=( $BUILDFLAGS "${ORIG_BUILDFLAGS[@]}" )
 : ${TIMEOUT:=120m}
 TESTFLAGS+=" -test.timeout=${TIMEOUT}"
 
+# --unresolved-symbols is not supported on Solaris
+EXTLDFLAGS_STATIC_DOCKER="$EXTLDFLAGS_STATIC -lpthread"
+if [ "$(uname -s)" != 'SunOS' ]; then
+	EXTLDFLAGS_STATIC_DOCKER="$EXTLDFLAGS_STATIC_DOCKER -Wl,--unresolved-symbols=ignore-in-object-files"
+fi
+
 LDFLAGS_STATIC_DOCKER="
 	$LDFLAGS_STATIC
 	-extldflags \"$EXTLDFLAGS_STATIC\"
diff --git a/hack/make/.detect-daemon-osarch b/hack/make/.detect-daemon-osarch
index f95afc4..4bc2a7a 100644
--- a/hack/make/.detect-daemon-osarch
+++ b/hack/make/.detect-daemon-osarch
@@ -2,17 +2,33 @@
 set -e
 
 # Retrieve OS/ARCH of docker daemon, eg. linux/amd64
-export DOCKER_ENGINE_OSARCH="$(docker version | awk '
+export DOCKER_ENGINE_OSARCH="$(docker version | gawk '
 	$1 == "Client:" { server = 0; next }
 	$1 == "Server:" { server = 1; next }
 	server && $1 == "OS/Arch:" { print $2 }
 ')"
 export DOCKER_ENGINE_GOOS="${DOCKER_ENGINE_OSARCH%/*}"
 export DOCKER_ENGINE_GOARCH="${DOCKER_ENGINE_OSARCH##*/}"
+DOCKER_ENGINE_GOARCH=${DOCKER_ENGINE_GOARCH:=amd64}
 
 # and the client, just in case
-export DOCKER_CLIENT_OSARCH="$(docker version | awk '
+export DOCKER_CLIENT_OSARCH="$(docker version | gawk '
 	$1 == "Client:" { client = 1; next }
 	$1 == "Server:" { client = 0; next }
 	client && $1 == "OS/Arch:" { print $2 }
 ')"
+
+# Retrieve the architecture used in contrib/builder/(deb|rpm)/$PACKAGE_ARCH/
+PACKAGE_ARCH="amd64"
+case "$DOCKER_ENGINE_OSARCH" in
+	linux/arm)
+		PACKAGE_ARCH='armhf'
+		;;
+	linux/ppc64le)
+		PACKAGE_ARCH='ppc64le'
+		;;
+	linux/s390x)
+		PACKAGE_ARCH='s390x'
+		;;
+esac
+export PACKAGE_ARCH
